//------------------------------------------------------------------------------------------------
//
//   SG Craft - Computercraft Interface Tile Entity
//
//------------------------------------------------------------------------------------------------

package gcewing.sg.cc;

import java.util.*;
import net.minecraft.world.*;
import net.minecraft.tileentity.*;
import dan200.computercraft.api.lua.*;
import dan200.computercraft.api.peripheral.*;

import gcewing.sg.*;

public class CCInterfaceTE extends BaseTileEntity implements IComputerInterface {

	Set<IComputerAccess> attachedComputers = new HashSet<IComputerAccess>();

	public void postEvent(TileEntity source, String name, Object... attrs) {
		//System.out.printf("CCInterfaceTE.postEvent: %s\n", name);
		World world = source.getWorldObj();
		CCRecord args = new CCRecord();
		args.add("world", world.getWorldInfo().getWorldName());
		args.add("dimension", world.provider.dimensionId);
		args.add("x", source.xCoord);
		args.add("y", source.yCoord);
		args.add("z", source.zCoord);
		for (int i = 0; i < attrs.length - 1; i += 2)
			args.add((String)attrs[i], attrs[i + 1]);
		for (IComputerAccess cpu : attachedComputers) {
			//System.out.printf("CCInterfaceTE.postEvent: to %s\n", cpu);
			cpu.queueEvent(name, new Object[]{args});
		}
	}
	
}

class CCRecord implements ILuaObject {

	static String[] aStringArray = {};

	ArrayList<String> names = new ArrayList<String>();
	ArrayList<Object> values = new ArrayList<Object>();
	
	public void add(String name, Object value) {
		names.add(name);
		values.add(value);
	}

	public String[] getMethodNames() {
		return names.toArray(aStringArray);
	}
	
	public Object[] callMethod(ILuaContext context, int method, Object[] arguments)
		throws LuaException, InterruptedException
	{
		return new Object[]{values.get(method)};
	}

}

